/*	File			NoughtsCrosses_General.h
	Purpose			Network Game (Noughts and Crosses) Common header code
	Author			Richard Anthony	(ar26@gre.ac.uk)
	Date			Updated January 2015 (originally December 2003)
*/

#pragma once

#define PORT 8000  // Default port 8000 decimal

#define MAX_ALIAS_LEN 15
enum MessageType {REGISTER_ALIAS, PLAYER_LIST, CHOOSE_OPPONENT, LOCAL_CELL_SELECTION,
					OPPONENT_CELL_SELECTION, START_OF_GAME, END_OF_GAME, 
					CLIENT_DISCONNECT};

enum CodeType {END_OF_GAME_DRAW, END_OF_GAME_WIN, END_OF_GAME_LOOSE};

struct Message_PDU {
	MessageType iMessageType;
	char cAlias[MAX_ALIAS_LEN +1];
	char cPlayerList[(MAX_ALIAS_LEN +1) *10]; //comma-separated list of alias'
	int iCell;
	CodeType iCode;
	int iToken;
	bool bFirstMove;
};

// Additional definitions for interaction with Directory Service
#define GAME_SERVER_NAME "GameServer"		// The name of the Game Server (as will be advertised by the Directory Service)
#define From_DIRECTORY_SERVICE_PORT	(u_int) 8002		// Fixed, defined by Directory Service
#define To_DIRECTORY_SERVICE_PORT	(u_int) 8008		// Fixed, defined by Directory Service

struct DirectoryServiceReply {                          // Fixed, defined by Directory Service
	// IP address followed by port
	unsigned char a1;
	unsigned char a2;
	unsigned char a3;
	unsigned char a4;
	unsigned int iPort;
	};